//
//  MyView.m
//  Example12C
//
//  Created by 川上 博 on 2015/10/28.
//  Copyright © 2015年 Hiroshi Kawakami. All rights reserved.
//

#import "MyView.h"
#include <math.h>

#define INCPI M_PI/71

void caustic(NSRect bounds, NSBezierPath *path)
{
    double r, t, u, x0, y0;
    
    x0=bounds.size.width/2.0;
    y0=bounds.size.height/2.0;
    r=MIN(x0,y0)-20.0;
    for(t=M_PI/2.0; t<1.5*M_PI; t+=INCPI)
    {
        u=3.0*t-M_PI;
        [path moveToPoint:NSMakePoint(x0+r*cos(t),y0+r*sin(t))];
        [path lineToPoint:NSMakePoint(x0+r*cos(u),y0+r*sin(u))];
    }
}

@implementation MyView

- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}

- (void)drawRect:(NSRect)dirtyRect {
    NSRect bounds = [self bounds];
    
    [[NSColor whiteColor] set];
    [NSBezierPath fillRect:bounds];
    
    [[NSColor blackColor] set];
    NSBezierPath *path=[NSBezierPath bezierPath];
    
    caustic(bounds, path);
    
    [path setLineWidth:1.0f];
    [path stroke];
}

@end